% Latent semantic analysis demo
% demo from http://webhome.cs.uvic.ca/~thomo/svd.pdf
% Jesse Chan, 3/27/2014

% d1 : Romeo and Juliet.
% d2 : Juliet: O happy dagger!
% d3 : Romeo died by dagger.
% d4 : ?Live free or die?, that?s the New-Hampshire?s motto.
% d5 : Did you know, New-Hampshire is in New-England

d{1} = {'Romeo', 'Juliet'};
d{2} = {'Juliet','happy', 'dagger'};
d{3} = {'Romeo', 'died' 'dagger'};
d{4} = {'Live','free', 'die', 'New Hampshire'};
d{5} = {'New Hampshire'};

%term ordering:
% 1. 'Romeo',
% 2. 'Juliet',
% 3. 'happy',
% 4. 'dagger',
% 5. 'live',
% 6. 'die',
% 7. 'free',
% 8. 'New Hampshire'

A = [1 0 1 0 0;
    1 1 0 0 0;
    0 1 0 0 0;
    0 1 1 0 0;
    0 0 0 1 0;
    0 0 1 1 0;
    0 0 0 1 0;
    0 0 0 1 1];

[U S V] = svd(A,'econ');

terms = (U(:,1:2)*S(1:2,1:2))';
docs = S(1:2,1:2)*V(:,1:2)';

query = zeros(8,1);
query([4 6]) = 1; % query for "dagger" and "die"
% query(1) = 1; % query for "romeo"
query = query/sum(query); % take average

q = terms*query;
ranking = zeros(5,1);
for i = 1:5
    ranking(i) = docs(:,i)'*q/(norm(docs(:,i))*norm(q));
end

[vals inds] = sort(ranking,'descend') % sort documents
